'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactVirtualized = require('react-virtualized');

var _reactDndScrollzone = require('react-dnd-scrollzone');

var _reactDndScrollzone2 = _interopRequireDefault(_reactDndScrollzone);

var _AdainTreeHeader = require('./AdainTreeHeader');

var _AdainTreeHeader2 = _interopRequireDefault(_AdainTreeHeader);

var AdainTree = (function (_React$Component) {
	_inherits(AdainTree, _React$Component);

	function AdainTree(props, context) {
		_classCallCheck(this, AdainTree);

		_get(Object.getPrototypeOf(AdainTree.prototype), 'constructor', this).call(this, props, context);

		this.state = {
			data: this.props.data || [],
			listHeight: 300,
			listRowHeight: 50,
			overscanRowCount: 10,
			rowCount: this.props.data ? this.props.data.length : 0,
			scrollToIndex: undefined,
			showScrollingPlaceholder: false
		};
	}

	_createClass(AdainTree, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			console.log("componentWillMount");
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			console.log("componentDidMount");
		}
	}, {
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(nextProps, nextState) {
			console.log("shouldComponentUpdate: " + JSON.stringify(nextProps) + " " + JSON.stringify(nextState));
			return true;
		}
	}, {
		key: 'componentWillUpdate',
		value: function componentWillUpdate(nextProps, nextState) {
			console.log("componentWillUpdate: " + JSON.stringify(nextProps) + " " + JSON.stringify(nextState));
		}
	}, {
		key: 'render',
		value: function render() {
			var _this = this;

			var _state = this.state;
			var listHeight = _state.listHeight;
			var listRowHeight = _state.listRowHeight;
			var overscanRowCount = _state.overscanRowCount;
			var rowCount = _state.rowCount;
			var scrollToIndex = _state.scrollToIndex;
			var showScrollingPlaceholder = _state.showScrollingPlaceholder;
			var useDynamicRowHeight = _state.useDynamicRowHeight;

			var containerStyle = { height: '100%' };

			console.log(this);

			return _react2['default'].createElement(
				'div',
				{ style: containerStyle },
				_react2['default'].createElement(_AdainTreeHeader2['default'], { header: this.props.header }),
				_react2['default'].createElement(
					_reactVirtualized.AutoSizer,
					{ disableHeight: true },
					function (_ref) {
						var width = _ref.width;
						return _react2['default'].createElement(_reactVirtualized.List, {
							ref: 'List',
							height: listHeight,
							overscanRowCount: overscanRowCount,
							noRowsRenderer: _this._noRowsRenderer.bind(_this),
							rowCount: rowCount,
							rowHeight: listRowHeight,
							rowRenderer: _this._rowRenderer.bind(_this),
							scrollToIndex: scrollToIndex,
							width: width
						});
					}
				)
			);
		}
	}, {
		key: 'search',
		value: function search() {}
	}, {
		key: 'moveNode',
		value: function moveNode() {}
	}, {
		key: 'startDrag',
		value: function startDrag(_ref2) {
			var path = _ref2.path;
		}
	}, {
		key: 'dragHover',
		value: function dragHover(_ref3) {
			var draggedNode = _ref3.node;
			var depth = _ref3.depth;
			var minimumTreeIndex = _ref3.minimumTreeIndex;
		}
	}, {
		key: 'endDrag',
		value: function endDrag(dropResult) {}
	}, {
		key: '_rowRenderer',
		value: function _rowRenderer(_ref4) {
			var index = _ref4.index;
			var isScrolling = _ref4.isScrolling;
			var key = _ref4.key;
			var style = _ref4.style;

			return _react2['default'].createElement(
				'div',
				{
					key: key,
					style: style,
					onClick: this._onClick.bind(this)
				},
				this.props.data[index].name
			);
		}
	}, {
		key: '_noRowsRenderer',
		value: function _noRowsRenderer() {
			return _react2['default'].createElement(
				'div',
				null,
				'No rows'
			);
		}
	}, {
		key: '_onClick',
		value: function _onClick(item) {
			console.log('on click', item);
			console.log('on click', this.props);
		}
	}, {
		key: '_onRowCountChange',
		value: function _onRowCountChange(event) {
			var rowCount = parseInt(event.target.value, 10) || 0;

			this.setState({ rowCount: rowCount });
		}
	}, {
		key: '_onScrollToRowChange',
		value: function _onScrollToRowChange(event) {
			var rowCount = this.state.rowCount;

			var scrollToIndex = Math.min(rowCount - 1, parseInt(event.target.value, 10));

			if (isNaN(scrollToIndex)) {
				scrollToIndex = undefined;
			}

			this.setState({ scrollToIndex: scrollToIndex });
		}
	}]);

	return AdainTree;
})(_react2['default'].Component);

exports['default'] = AdainTree;
module.exports = exports['default'];